/*  Created: 15.11.2016
    Author: Dmitry Vasiliev
    Text editor: Sublime Text
    GitHub: swimmwatch  */


(function($) {

  function updateTabsState() {
    let index = $(this).index(), // Index the current element.
        tabsItems = $(this).parent(), // .tabs__items the current element.
        tabsContent = $(this).parent().next(); // .tabs__content the current element.

    // Reset at every class .tabs_active
    tabsItems
      .find('.tabs__item')
      .each(function() {
         $(this).removeClass('tabs_active');
       });
    tabsContent
      .find('.tabs__content')
      .each(function(){
        $(this).removeClass('tabs_active');
      });

    $(this).addClass('tabs_active'); // Add class at the current element.
    tabsContent.find('.tabs__content').eq(index).addClass('tabs_active'); // Add class it content.
  }

  function updateHashState() {
    let hash = location.hash,
        itemsWithHash = $(`.tabs__item[data-hash="${hash}"]`); // Find all .tabs__item with data-hash attribute.

    if (!itemsWithHash.length) return; // If don't found stop.

    itemsWithHash.each(updateTabsState); // Update state of the current tab.
  }

  $(window).on('load', updateHashState);
  $(window).on('hashchange', updateHashState);

  let DelegateCallback = function() {
    $('.tabs__item').click(updateTabsState);
    updateHashState();
  };

  // Observer for all mutations of DOM.
  let observer =
  new MutationObserver(DelegateCallback)
  .observe(document.body, {
    childList: true,
    subtree: true
  });

}(jQuery));